      PROGRAM PLOT
C *** --------------------------------------------------------------------
C     THIS PROGRAM PLOTS CONTOUR LINE IN N.H. ON GAUSSIAN LATITUDES
C *** --------------------------------------------------------------------
C
      PARAMETER(IM=148,JM=93,NOVLI=4,JMP1=JM+1,IMM4=IM-4,JMM2=JM-2
     1,         PDPHD=2.0,PDLMD=2.5,IDIRECT=1,IFUVFI=3)
C-----------------------------------------------------------------
C    IDIRECT=0: plot geopotential from multigrid solver
C           =1: plot geopotential from direct solver
C           =2: plot error field between direct solver and multigrid solver
C    IFUVFI=1: plot the error field for U-component data
C          =2: plot the error field for V-component data
C          =3: plot the error field for FI-data
C-----------------------------------------------------------------------
      PARAMETER(JCAP=40,       LEVS=18,
     1          LONF=IM-NOVLI, LONF2=LONF*2,
     2          LATG=JM-2,     LONFHF=LONF/2,
     3          LEVH=18,
     3          IMX=LONF+1                 )
C ...
      REAL	COLRAD (LATG),   WGT   (LATG),
     1          WGTCS  (LATG),   RCS2  (LATG)
C
C
      REAL UFI(IM,JMP1), VFI(IM,JMP1), FI(IM,JMP1)
C
      REAL H(IMX,LATG),spv(2) 
C
      CHARACTER *39 ID
      CHARACTER *10 ABC
      COMMON /TRANS1/GLON(IMX)
      COMMON /TRANS2/RAD(LATG)
c      COMMON /TRANS/MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX,W
      COMMON /CONRE1/IOFFP,SPVAL
C
C
      DATA ALNMN,ALNMX,ALTMN,ALTMX/0., 360., -90., 90./
      DATA flo, hi, len/0.,0.,30/
      DATA nset,ispv/1,0/
      DATA spv/0.,0./
C
      CONINT=600.0
      IF(IDIRECT.EQ.2) CONINT=-4
C      
      W=0.01
      MA=IMX
      NA=LATG
      ITRANS=2
      IOFFP=1
      SPVAL=0.
C
      DO 10 J=1,LATG
      RAD(J)=-90.0+FLOAT(J-1)*180.0/FLOAT(LATG-1)
10    CONTINUE
      DO 20 I=1,LONF
      GLON(I)=FLOAT(I-1)*360.0/FLOAT(LONF)
20    CONTINUE
      GLON(IMX)=360.0
C
      OPEN(UNIT=45, FILE='fort.45', STATUS='OLD', 
     1                          FORM='FORMATTED')
      PI=4.*ATAN(1.)
      PRINT*,'PI=',PI
C
      CALL OPNGKS
      DO 611 K=1,9999
      PRINT*,'starting reading data'
C ... READ DATA FIELD TO BE PLOTED
	IF(IDIRECT.EQ.0) IWR=46
	IF(IDIRECT.EQ.1) IWR=45
	IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.1) IWR=47
	IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.2) IWR=48
	IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.3) IWR=49
        READ(IWR,711,END=888) ABC, THOURS
      READ(IWR,911)((FI(I,J),I=1,IMM4),J=1,JMM2)
      READ(IWR,911)((FI(I,J),I=1,IMM4),J=1,JMM2)
      READ(IWR,911)((FI(I,J),I=1,IMM4),J=1,JMM2)
 911  FORMAT(1X,10E13.6)
 711  FORMAT(10X,A10,F6.1)
CCC
      IF(IDIRECT.EQ.0) WRITE(ID,30) THOURS
      IF(IDIRECT.EQ.1) WRITE(ID,31) THOURS
      IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.1) WRITE(ID,32) THOURS
      IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.2) WRITE(ID,33) THOURS
      IF(IDIRECT.EQ.2.AND.IFUVFI.EQ.3) WRITE(ID,34) THOURS
30    FORMAT(1X,'GEOP: MULTIGRID SOLVER. T=',F6.1) 
31    FORMAT(1X,'   GEOP: DIRECT SOLVER. T=',F6.1) 
32    FORMAT(1X,'DIFF OF U:DIR AND MLTI. T=',F6.1) 
33    FORMAT(1X,'DIFF OF V:DIR AND MLTI. T=',F6.1) 
34    FORMAT(1X,'DIF OF FI:DIR AND MLTI. T=',F6.1) 

      DO 50 J=1,LATG
         DO 40 I=1,LONFHF
            H(I  ,J)=FI(LONFHF+I,J)
            H(LONFHF+I,J)=FI(I,J)
 40      CONTINUE
         H(IMX,J)=H(1,J)
 50   CONTINUE

      CONINT=600.0
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRITY(0.5,0.975,ID,39,3,0,0)
      CALL SUPMAP(8,0.,180.,0.,-90.,0.,90.,360.,2,1030,2,1,IER)
      CALL CONREC(H,IMX,IMX,LATG,0.0,0.0,CONINT,1,-1,-99)
      CALL FRAME
C
 611  CONTINUE
 888  CONTINUE

      CALL CLSGKS
C
      STOP
      END
C
      SUBROUTINE GLATS(KHALF,COLRAD,WGT,WGTCS,RCS2)
      PARAMETER (LATG=10, LATG2=LATG/2)
      DIMENSION COLRAD( LATG2),WGT( LATG2),WGTCS( LATG2),RCS2( LATG2)   
      DOUBLE PRECISION        EPS, SI, RK2, SCALE, PI, DRADZ, RAD,      
     1 DRAD, P1, P2, PHI, W, X, SN, RC                                  
C                                                                       
      EPS=1.D-12                                                        
C     PRINT 101                                                         
C101  FORMAT ('0 I   COLAT   COLRAD     WGT', 12X, 'WGTCS',             
C    1 10X, 'ITER  RES')                                                
      SI=1.D+00                                                         
      K2=2*KHALF                                                        
      RK2=K2                                                            
      SCALE=2.D+00/(RK2**2)                                             
      K1=K2-1                                                           
      PI=DATAN(SI)*4.D+00                                               
      DRADZ=PI/360.D+00                                                 
      RAD=0.D+00                                                        
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -B-              
C                                                                       
      DO 1000 K=1,KHALF                                                 
      ITER=0                                                            
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -C-              
C                                                                       
      DRAD=DRADZ                                                        
1     CONTINUE                                                          
      CALL POLY(K2,RAD,P2)                                              
2     CONTINUE                                                          
      P1 = P2                                                           
      ITER=ITER+1                                                       
      RAD=RAD+DRAD                                                      
      CALL POLY(K2,RAD,P2)                                              
      IF(DSIGN(SI,P1).EQ.DSIGN(SI,P2))GO TO 2                           
      IF(DRAD.LT.EPS)GO TO 3                                            
      RAD=RAD-DRAD                                                      
      DRAD=DRAD*0.25D+00                                                
      GO TO 1                                                           
3     CONTINUE                                                          
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -D-              
C                                                                       
      COLRAD(K)=SNGL(RAD)                                               
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -E-              
C                                                                       
      PHI=RAD   *180.D+00/PI                                            
      CALL POLY(K1,RAD,P1)                                              
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -F-              
C                                                                       
      X=DCOS(RAD)                                                       
      W=SCALE*(1.D+00-X*X)/(P1*P1)                                      
      WGT(K)=SNGL(W)                                                    
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -G-              
C                                                                       
      SN=DSIN(RAD)                                                      
      W=W/(SN*SN)                                                       
      WGTCS(K)=SNGL(W)                                                  
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -H-              
C                                                                       
      RC=1./(SN*SN)                                                     
      RCS2(K)=SNGL(RC)                                                  
      CALL POLY(K2,RAD,P1)                                              
      PRPHI = SNGL(PHI)                                                 
      PRCOL = COLRAD(K)                                                 
C     PRINT 102, K, PRPHI, PRCOL, WGT(K), WGTCS(K), ITER, P1            
C102  FORMAT(1H ,I2,2X,F6.2,2X,F10.7,2X,E13.7,2X,E13.7,2X,I4,2X,D13.7)  
1000  CONTINUE                                                          
C                                                                       
C                   DOCUMENTATION REFERENCE POINT      -I-              
C                                                                       
C(DEBUGLINE)ANSI VER CREATED SEP 30 1982 BY J.SELA,NMC.                 
      RETURN                                                            
      END                                                               
      SUBROUTINE POLY(N,RAD,P)                                          
      DOUBLE PRECISION X,RAD,P,Y1,Y2,Y3,G                               
      X=DCOS(RAD)                                                       
      Y1=1.D+0                                                          
      Y2=X                                                              
      DO 1 I=2,N                                                        
      G=X*Y2                                                            
      Y3=G-Y1+G-(G-Y1)/FLOAT(I)                                         
      Y1=Y2                                                             
      Y2=Y3                                                             
1     CONTINUE                                                          
      P=Y3                                                              
      RETURN                                                            
      END     
C                                                          
      BLOCKDATA CONBD
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(1500)   ,NR
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE
      COMMON /RECINT/ IRECMJ     ,IRECMN     ,IRECTX
      DATA IOFFP,SPVAL/0,0.0/
      DATA ISIZEL,ISIZEM,ISIZEP,NLA,NLM,XLT,YBT,SIDE,ISOLID,NREP,NCRT/
     1       1,  2,   0, 16, 40,.05,.05,  .9,  1023,   6,   4 /
      DATA EXT,IOFFD,NULBLL,IOFFM,ILAB/.25,0,3,0,1/
      DATA INX(1),INX(2),INX(3),INX(4),INX(5),INX(6),INX(7),INX(8)/
     1        -1 ,   -1 ,    0 ,    1 ,    1 ,    1 ,    0 ,   -1 /
      DATA INY(1),INY(2),INY(3),INY(4),INY(5),INY(6),INY(7),INY(8)/
     1         0 ,    1 ,    1 ,    1 ,    0 ,   -1 ,   -1 ,   -1 /
      DATA NR/1500/
      DATA IRECMJ,IRECMN,IRECTX/ 1 ,   1 ,   1/
C
C REVISION HISTORY---
C
C JANUARY 1980     ADDED REVISION HISTORY AND CHANGED LIBRARY NAME
C                  FROM CRAYLIB TO PORTLIB FOR MOVE TO PORTLIB
C
C MAY 1980         ARRAYS IWORK AND ENCSCR, PREVIOUSLY TOO SHORT FOR
C                  SHORT-WORD-LENGTH MACHINES, LENGTHENED.  SOME
C                  DOCUMENTATION CLARIFIED AND CORRECTED.
C
C JUNE 1984        CONVERTED TO FORTRAN 77 AND TO GKS
C
C JUNE 1985        ERROR HANDLING LINES ADDED; IF OVERFLOW HAPPENS TO
C                  WORK ARRAY IN STLINE, A WARNING MESSAGE IS WRITTEN
C                  BOTH ON PLOT FRAME AND ON STANDARD ERROR MESSAGE.
C-------------------------------------------------------------------
C
      END
      SUBROUTINE STLINE (Z,LL,MM,NN,CONV)
      SAVE
      DIMENSION       Z(LL,NN)
C
C THIS ROUTINE FINDS THE BEGINNINGS OF ALL CONTOUR LINES AT LEVEL CONV.
C FIRST THE EDGES ARE SEARCHED FOR LINES INTERSECTING THE EDGE (OPEN
C LINES) THEN THE INTERIOR IS SEARCHED FOR LINES WHICH DO NOT INTERSECT
C THE EDGE (CLOSED LINES).  BEGINNINGS ARE STORED IN IR TO PREVENT RE-
C TRACING OF LINES.  IF IR IS FILLED, THE SEARCH IS STOPPED FOR THIS
C CONV.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(1500)   ,NR
      COMMON /CONRE3/ IXBITS     ,IYBITS
C
C
C
C
C
C
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
C
      L = LL
      M = MM
      N = NN
      CV = CONV
      NP = 0
      ISS = 0
      DO 102 IP1=2,M
         I = IP1-1
         IF (Z(I,1).GE.CV .OR. Z(IP1,1).LT.CV) GO TO 101
         IX = IP1
         IY = 1
         IDX = -1
         IDY = 0
         IS = 1
         CALL DRLINE (Z,L,M,N)
  101    IF (Z(IP1,N).GE.CV .OR. Z(I,N).LT.CV) GO TO 102
         IX = I
         IY = N
         IDX = 1
         IDY = 0
         IS = 5
         CALL DRLINE (Z,L,M,N)
  102 CONTINUE
      DO 104 JP1=2,N
         J = JP1-1
         IF (Z(M,J).GE.CV .OR. Z(M,JP1).LT.CV) GO TO 103
         IX = M
         IY = JP1
         IDX = 0
         IDY = -1
         IS = 7
         CALL DRLINE (Z,L,M,N)
  103    IF (Z(1,JP1).GE.CV .OR. Z(1,J).LT.CV) GO TO 104
         IX = 1
         IY = J
         IDX = 0
         IDY = 1
         IS = 3
         CALL DRLINE (Z,L,M,N)
  104 CONTINUE
      ISS = 1
      DO 108 JP1=3,N
         J = JP1-1
         DO 107 IP1=2,M
            I = IP1-1
            IF (Z(I,J).GE.CV .OR. Z(IP1,J).LT.CV) GO TO 107
            IXY = IXYPAK(IP1,J)
            IF (NP .EQ. 0) GO TO 106
            DO 105 K=1,NP
               IF (IR(K) .EQ. IXY) GO TO 107
  105       CONTINUE
  106       NP = NP+1
            IF (NP .GT. NR) THEN
C
C THIS PRINTS AN ERROR MESSAGE IF THE LOCAL ARRAY IR IN SUBROUTINE
C STLINE HAS AN OVERFLOW
C THIS MESSAGE IS WRITTEN BOTH ON THE FRAME AND ON THE STANDARD ERROR
C UNIT
C
      IUNIT = I1MACH(4)
      WRITE(IUNIT,1000)
 1000 FORMAT(
     1' WARNING FROM ROUTINE STLINE IN CONREC--WORK ARRAY OVERFLOW')
      CALL GETSET(VXA,VXB,VYA,VYB,XA,XB,YA,YB,LTYPE)
      Y = (YB - YA) / 2.
      X = (XB - XA) / 2.
      CALL PWRIT(X,Y,
     1'**WARNING--PICTURE INCOMPLETE**',
     2 31,3,0,0)
      Y = Y * .7
      CALL PWRIT(X,Y,
     1'WORK ARRAY OVERFLOW IN STLINE',
     2 29,3,0,0)
        RETURN
        ENDIF
            IR(NP) = IXY
            IX = IP1
            IY = J
            IDX = -1
            IDY = 0
            IS = 1
            CALL DRLINE (Z,L,M,N)
  107    CONTINUE
  108 CONTINUE
      RETURN
      END
      SUBROUTINE DRLINE (Z,L,MM,NN)
      SAVE
      DIMENSION       Z(L,NN)
C
C THIS ROUTINE TRACES A CONTOUR LINE WHEN GIVEN THE BEGINNING BY STLINE.
C TRANSFORMATIONS CAN BE ADDED BY DELETING THE STATEMENT FUNCTIONS FOR
C FX AND FY IN DRLINE AND MINMAX AND ADDING EXTERNAL FUNCTIONS.
C X=1. AT Z(1,J), X=FLOAT(M) AT Z(M,J). X TAKES ON NON-INTEGER VALUES.
C Y=1. AT Z(I,1), Y=FLOAT(N) AT Z(I,N). Y TAKES ON NON-INTEGER VALUES.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(1500)   ,NR
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE3/ IXBITS     ,IYBITS
      LOGICAL         IPEN       ,IPENO
C
C
C     STATEMENT FUNCTIONS TO BE REPLACED IF NON-IDENTITY
C     TRANSFORMATIONS ARE DESIRED.
C
      EXTERNAL FX, FY
C     FX(X,Y) = X
C     FY(X,Y) = Y
C
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
      C(P1,P2) = (P1-CV)/(P1-P2)
C
      DATA IPEN,IPENO/.TRUE.,.TRUE./
C
      M = MM
      N = NN
      IF (IOFFP .EQ. 0) GO TO 101
      ASSIGN 110 TO JUMP1
      ASSIGN 115 TO JUMP2
      GO TO 102
  101 ASSIGN 112 TO JUMP1
      ASSIGN 117 TO JUMP2
  102 IX0 = IX
      IY0 = IY
      IS0 = IS
      IF (IOFFP .EQ. 0) GO TO 103
      IX2 = IX+INX(IS)
      IY2 = IY+INY(IS)
      IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL
      IPENO = IPEN
  103 IF (IDX .EQ. 0) GO TO 104
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO 105
  104 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
  105 CALL FRSTD (FX(X,Y),FY(X,Y))
  106 IS = IS+1
      IF (IS .GT. 8) IS = IS-8
      IDX = INX(IS)
      IDY = INY(IS)
      IX2 = IX+IDX
      IY2 = IY+IDY
      IF (ISS .NE. 0) GO TO 107
      IF (IX2.GT.M .OR. IY2.GT.N .OR. IX2.LT.1 .OR. IY2.LT.1) GO TO 120
  107 IF (CV-Z(IX2,IY2)) 108,108,109
  108 IS = IS+4
      IX = IX2
      IY = IY2
      GO TO 106
  109 IF (IS/2*2 .EQ. IS) GO TO 106
      GO TO JUMP1,(110,112)
  110 ISBIG = IS+(8-IS)/6*8
      IX3 = IX+INX(ISBIG-1)
      IY3 = IY+INY(ISBIG-1)
      IX4 = IX+INX(ISBIG-2)
      IY4 = IY+INY(ISBIG-2)
      IPENO = IPEN
      IF (ISS .NE. 0) GO TO 111
      IF (IX3.GT.M .OR. IY3.GT.N .OR. IX3.LT.1 .OR. IY3.LT.1) GO TO 120
      IF (IX4.GT.M .OR. IY4.GT.N .OR. IX4.LT.1 .OR. IY4.LT.1) GO TO 120
  111 IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL .AND.
     1       Z(IX3,IY3).NE.SPVAL .AND. Z(IX4,IY4).NE.SPVAL
  112 IF (IDX .EQ. 0) GO TO 113
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO 114
  113 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
  114 GO TO JUMP2,(115,117)
  115 IF (.NOT.IPEN) GO TO 118
      IF (IPENO) GO TO 116
C
C END OF LINE SEGMENT
C
      CALL LASTD
      CALL FRSTD (FX(XOLD,YOLD),FY(XOLD,YOLD))
C
C CONTINUE LINE SEGMENT
C
  116 CONTINUE
  117 CALL VECTD (FX(X,Y),FY(X,Y))
  118 XOLD = X
      YOLD = Y
      IF (IS .NE. 1) GO TO 119
      NP = NP+1
      IF (NP .GT. NR) GO TO 120
      IR(NP) = IXYPAK(IX,IY)
  119 IF (ISS .EQ. 0) GO TO 106
      IF (IX.NE.IX0 .OR. IY.NE.IY0 .OR. IS.NE.IS0) GO TO 106
C
C END OF LINE
C
  120 CALL LASTD
      RETURN
      END

      SUBROUTINE MINMAX (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C ORIGINATOR       DAVID KENNISON
C
      SAVE
      CHARACTER*6     IA
      DIMENSION       Z(L,NN)
C
C
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE5/ SCLY
C
      EXTERNAL FX, FY
C     FX(X,Y) = X
C     FY(X,Y) = Y
C
      M = MM
      N = NN
C
C SET UP SCALING FOR LABELS
C
      SIZEM = (ISSIZM + 1)*256*SCLY
      ISIZEM = ISSIZM
C
      ASH = ABS(AASH)
      IOFFDT = JOFFDT
C
      IF (AASH .LT. 0.0) GO TO 128
C
      MN = MIN0(15,MAX0(2,IFIX(FLOAT(M)/8.)))
      NM = MIN0(15,MAX0(2,IFIX(FLOAT(N)/8.)))
      NM1 = N-1
      MM1 = M-1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = MAX0(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = MIN0(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = MAX0(1,JP-NM)
         JT = MIN0(N,JP+NM)
         IS = MAX0(1,IP-MN)
         IT = MIN0(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 112
  110       CONTINUE
  111    CONTINUE
C
         X = FLOAT(IP)
         Y = FLOAT(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'H',ISIZEM,0,0 )
         CALL FL2INT ( FX(X,Y),FY(X,Y),IFX,IFY )
C
C SCALE TO USER SET RESOLUTION(NO PNLT)
C
         IFY = IFY*SCLY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = MAX0(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = MIN0(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = MAX0(1,JP-NM)
         JT = MIN0(N,JP+NM)
         IS = MAX0(1,IP-MN)
         IT = MIN0(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
         X = FLOAT(IP)
         Y = FLOAT(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'L',ISIZEM,0,0 )
         CALL FL2INT( FX(X,Y),FY(X,Y),IFX,IFY )
         IFY = SCLY*IFY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (IOFFP.NE.0 .AND. Z(IP+1,JP).EQ.SPVAL) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN
C
C ****************************** ENTRY PNTVAL **************************
C     ENTRY PNTVAL (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
  128 CONTINUE
      II = (M-1+24)/24
      JJ = (N-1+48)/48
      NIQ = 1
      NJQ = 1
      DO 130 J=NJQ,N,JJ
         Y = J
         DO 129 I=NIQ,M,II
            X = I
            ZZ = Z(I,J)
            IF (IOFFP.NE.0 .AND. ZZ.EQ.SPVAL) GO TO 129
            CALL ENCD (ZZ,ASH,IA,NC,IOFFDT)
            CALL WTSTR (FX(X,Y),FY(X,Y),IA(1:NC),ISIZEM,0,0 )
  129    CONTINUE
  130 CONTINUE
      RETURN
      END

      function fx(x,y)
      common /TRANS1/ rlon(200)
      common /TRANS2/ rlat(100)
      xlon=rlon(ifix(x))+(rlon(ifix(x)+1)-rlon(ifix(x)))*(x-aint(x))
      ylat=rlat(ifix(y))+(rlat(ifix(y)+1)-rlat(ifix(y)))*(y-aint(y))
      call maptrn(ylat,xlon,xans,yans)
      fx=xans
      return
      end

      function fy(x,y)
      common /TRANS1/ rlon(200)
      common /TRANS2/ rlat(100)
      xlon=rlon(ifix(x))+(rlon(ifix(x)+1)-rlon(ifix(x)))*(x-aint(x))
      ylat=rlat(ifix(y))+(rlat(ifix(y)+1)-rlat(ifix(y)))*(y-aint(y))
      call maptrn(ylat,xlon,xans,yans)
      fy=yans
      return
      end


