CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     This file contains the subroutines which correspond to      C
C     the file slgcm.inout in the 3D model.                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE INPUT

      include "slgcm.slgprm"
      include "slgcm.slgwrk"
      include "slgcm.slgprg"
      include "slgcm.slgcon"

      COMMON /INOUT/ DT, INITC

      DOUBLE PRECISION TAU
C
      INTEGER    DT, RDHOUR, DTFL
      LOGICAL    GEOPL, DFTFLG

      NAMELIST /INLIST/ DELT,  MSTEP, RDHOUR,  DIVDMP, DDMPB, DDMPF
     *,                 TEXTT, TEXTN, TEXPT, TEXPN, EPSS, GEOPL
     *,                 DFTFLG, KRSI, TAUS, TAUC

      NAMELIST /OUTLIST/ IOHOUR, KRSO

      CDF   = 1.0
C
      READ(51,INLIST)
      READ(51,OUTLIST)
      WRITE(6,INLIST)
      WRITE(6,OUTLIST)
C
      DT = DELT + 0.0001
      CDAMP  = DIVDMP
C
      TEXF1  = TEXTT
      TEXF2  = TEXTN
      TEXFa  = TEXPT
      TEXFb  = TEXPN
c
      DL1    = 0.5 * (1.0 + EPSS)
      DL2    = 1.0 - DL1

      CALL SLGCM(DT)

Cyli      CALL SLGCM(-DT)
      RETURN
      END


      SUBROUTINE DGFILTR(DT,TAUSS,TAUCC)

      include 'slgcm.slgprm'
      include 'slgcm.slgprg'
      include 'slgcm.slgcon'

      DIMENSION UOR(IJM0M0), VOR(IJM0M0), GTPOR(IJM0M0)
      DIMENSION HF(0:1000)

      INTEGER DT
      LOGICAL FIRST

      TAUS = TAUSS*3600.0
      TAUC = TAUCC*3600.0

      RDT = DT
      NIN = TAUS/(2.0*RDT)
      THETAC = PI*TAUS/(NIN*TAUC)


      HF(0) = THETAC/PI
      TEMH = HF(0)

      DO I=1,NIN
         TEM1 = FLOAT(I)*PI/FLOAT(NIN+1)
         HF(I) = (SIN(TEM1)/TEM1)
     #          *(SIN(FLOAT(I)*THETAC)/(FLOAT(I)*PI))
         TEMH = TEMH + 2.0*HF(I)
      ENDDO

      DO I = 0, NIN
         HF(I) = HF(I)/TEMH
      ENDDO

      print*, ' NIN =', NIN, ' TEMH =',TEMH, '  THETAC=', THETAC

      DO I=0, NIN
         PRINT*, 'I=', I, '   HF(I)=', HF(I)
      ENDDO

      UOR(:) = HF(0)*UN0(:)
      VOR(:) = HF(0)*VN0(:)
      GTPOR(:) = HF(0)*GTP(:)

      CALL CONDT(DT)
      FIRST = .TRUE.
      DO N = 1, NIN
         CALL SLGCST(RDT,FIRST)
         UOR(:) = HF(N)*UN0(:) + UOR(:)
         VOR(:) = HF(N)*VN0(:) + VOR(:)
         GTPOR(:) = HF(N)*GTP(:) + GTPOR(:)
      ENDDO

      MDT = DT
      DT = -MDT
      RDT = DT

      CALL CONDT(DT)
      FIRST = .TRUE.
      DO N = 1, NIN
         CALL SLGCST(RDT,FIRST)
         UOR(:) = HF(N)*UN0(:) + UOR(:)
         VOR(:) = HF(N)*VN0(:) + VOR(:)
         GTPOR(:) = HF(N)*GTP(:) + GTPOR(:)
      ENDDO
      
      FIRST = .TRUE.
      DT = MDT

      UN0(:) = UOR(:)
      VN0(:) = VOR(:)
      GTP(:) = GTPOR(:)

      RETURN
      END


