CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       This file contains the subroutines corresponding to     C
C       slgcm.main in the 3D model.                             C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      PROGRAM SLGCMN
      
      CALL CONSL
      CALL INPUT
      STOP
      END

      SUBROUTINE SLGCM(DT)

      include "slgcm.slgprm"
      include "slgcm.slgprg"
      include "slgcm.slgcon"

      LOGICAL  GEOPL, DFTFLG

      NAMELIST /INLIST/ DELT,  MSTEP, RDHOUR,  DIVDMP, DDMPB, DDMPF
     *,                 TEXTT, TEXTN, TEXPT, TEXPN, EPSS, GEOPL
     *,                 DFTFLG, KRSI, TAUS, TAUC
           
      NAMELIST /OUTLIST/ IOHOUR, KRSO

      DIMENSION FIWK(IM,JM), AAAU(IM,JM), AAAV(IM,JM), AAAF(IM,JM)
     *,         AAAF3(IMP3,JM)
      
      COMMON /MEAN/FMEAN

      INTEGER  DT
      LOGICAL FIRST
      CHARACTER*10, ABC

      REWIND(51)
      READ(51,INLIST)
      READ(51,OUTLIST)

      MMM = 0
      RDT      = DT

      PRINT *, '    TIME STEP WILL BE ',DT,' SECS.'

      CALL CONDT(DT)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     STEP 1:  SPECIFY THE INITIAL CONDITION FOR THE SHALLOW WATER C
C     EQUATION MODEL.                                              C

      IF(GEOPL) THEN
         VM = 20.0
         CALL GEOPOL(VM)
      ELSE
         CALL INIT(KRSI)
      ENDIF

      IF(DFTFLG) THEN
         CALL DGFILTR(DT,TAUS,TAUC)
         CALL CONDT(DT)
         RDT = DT
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      FIRST = .TRUE.

      write(6,888)
      write(6,999)
      write(6,1110)
      write(6,999)

100   CONTINUE

C     
C     Calculate the global kinetic energy (TKE), global potential 
C     energy (POT), total energy (EG) and the global mean of 
C     geopotential perturbation (GMASS, in meters) which is an
C     indicator of the mass conservation.
C
      CALL ENGCH(TKEU,TKEV,TKE,POT,EG,GMASS)

      THOURS = MMM*(DT/ABS(DT))

      NMM = MMM*DT/(IOHOUR*3600)
      KMM = NMM*IOHOUR
      LMM = KMM - MMM
      IF(LMM.EQ.0) THEN
Cyli      IF(MMM.EQ.48) THEN
      MHOUR = (MMM*DT)/3600
      write(6,1111) MHOUR,TKE,POT,EG,GMASS
      DO I=1,IM
         DO J=1,JM
            II = (J-1)*IMP3 + I
            FIWK(I,J) = GTP(II) + FMEAN
         ENDDO
      ENDDO
      write(KRSO,811) THOURS
      write(KRSO,911)((FIWK(I,J),I=1,IM),J=1,JM)
      ENDIF

      CALL SLGCST(RDT, FIRST)
      
      MMM = MMM + 1
      
      IF (MMM .GE. MSTEP) THEN
         GO TO 101
      ENDIF

      GO TO 100

101   CONTINUE

 711  format(10x,A10,F6.1)
 811  FORMAT(10X,'Time Step=',F6.1)
 911  FORMAT(1X,10E13.6)
 888  FORMAT(/,/,/)
 999  FORMAT('****************************************'
     #,      '********************************************')
 1110 FORMAT('*---Time---', '--KINETIC ENERGY--'
     #,         '--POT. ENERGY--',  '--TOTAL ENERGY--'
     #,         '--MASS EXCESS(METERS)--*')
 1111 FORMAT(1X, 'HOURS=',I4,'  TKE=',E11.4, '  POT=',E11.4
     #,          '  EG=',E11.4, '  GMASS=',E11.4)
                
      RETURN
      END
