CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     This file corresponds to the slgcm.misc for the 3D model    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE AVRX3(U,V)
      include "slgcm.slgprm"
      include "slgcm.slgwrk"
C
C*********************************************************************
C*********************** SLGCM   MODEL *******************************
C********************* SUBROUTINE AVRX *******************************
C********************** 08 OCTO    1992 ******************************
C*********************************************************************
C
C
      PARAMETER (NLATS=JM/8)
C
      INTEGER   TOTLATS, TEMPSIZE, FORWARD, BACKWARD
C
      PARAMETER (TOTLATS=4*NLATS)
      PARAMETER (TEMPSIZE=TOTLATS*IMP2, ITRG=3*IMP2+1)
      PARAMETER (FORWARD=-1,BACKWARD=1)
C
C  ARGUMENTS
C
      DIMENSION    U(IMP3,JM), V(IMP3,JM)
     *,            S(IMP2,TOTLATS), TR(ITRG), IX(IM)
C
C   LOCALS
C
      LOGICAL        FIRST
C
C   SCRATCH SPACE ALLOCATION
C
      DIMENSION      A(IMP2,TOTLATS), B(IM*2,TOTLATS)
      DIMENSION      F(IMP2,JMM1),    Z(IMP3,TOTLATS)
C
      DATA           FIRST/.TRUE./
      DATA S/TEMPSIZE*0.0/, TR/ITRG*0.0/, IX/IM*0/
      SAVE
C
C   INITIALIZATION ON FIRST CALL
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C
         DO 10 I=1,IMP2*JMM1
         F(I,1) = 1.
   10    CONTINUE
         CONS   = ONE / COS(-PI/TWO+(NLATS+1)*(PI/JMM1))
C
         DO 100 I=4,IM
         ANGI = SIN((I/2)*PI/IM)
         DO 100 J=2,JMM1
         TEM      = CONS * COS(-PI/TWO + (J-1)*(PI/JMM1))
         F(I+1,J) = MIN(TEM*TEM/ANGI,ONE)
100      CONTINUE
C
         DO 200 I=1,IMP2
         DO 200 J=1,NLATS
         S(I,J      ) = F(I,         1 +J)
         S(I,J+NLATS) = F(I,JM-NLATS-1 +J)
         S(I,J+2*NLATS) = S(I,J)
         S(I,J+3*NLATS) = S(I,J+NLATS)
200      CONTINUE
C
         CALL FFTFAX(IM, IX, TR)
C
      ENDIF
C
C       END INITIALIZATION
C**********************************************************************
C       BEGIN STANDARD CASE
C
C   COPY LATITUDES TO BE SMOOTHED INTO CONTIGUOUS BUFFER
C
      IOFF = 1
      DO 1003 I=1,IMP3*NLATS
      Z(I,IOFF)         = U(I,2)
      Z(I,NLATS+IOFF)   = U(I,JM-NLATS)
      Z(I,2*NLATS+IOFF) = V(I,2)
      Z(I,3*NLATS+IOFF) = V(I,JM-NLATS)
1003  CONTINUE
C
C   TRANSFORM AND FILTER
C
      DO 1100 J=1,TOTLATS
      DO 1100 I=1,IMP2
      A(I,J) = Z(I,J)
1100  CONTINUE
C
      CALL RFFTMLT(A,B,TR,IX,1,IMP2,IM,TOTLATS,FORWARD)
C
      DO 1110 I=1,IMP2*TOTLATS
      A(I,1) = A(I,1)*S(I,1)
 1110 CONTINUE
C
      CALL RFFTMLT(A,B,TR,IX,1,IMP2,IM,TOTLATS,BACKWARD)
C
      DO 1500 J=1,TOTLATS
      DO 1450 I=1,IM
      Z(I,J) = A(I,J)
1450  CONTINUE
      Z(IMP1,J) = Z(1,J)
      Z(IMP2,J) = Z(2,J)
      Z(IMP3,J) = Z(3,J)
1500  CONTINUE
C
C   COPY BACK FROM CONTIGUOUS BUFFER
C
      IOFF = 1
      DO 1645 I=1,IMP3*NLATS
      U(I,2)        = Z(I,IOFF)
      U(I,JM-NLATS) = Z(I,NLATS+IOFF)
      V(I,2)        = Z(I,2*NLATS+IOFF)
      V(I,JM-NLATS) = Z(I,3*NLATS+IOFF)
1645  CONTINUE
C
      RETURN
      END
      SUBROUTINE CONSL

      include "slgcm.slgprm"
      include "slgcm.slgclm"
      include "slgcm.slgwrk"
      include "slgcm.slgcon"
C
      DO 220 J=1,JM
      PH(J,2) = -PIO2  + (J-1)*DPH
      PH(J,1) = PH(J,2) + 0.5*DPH
  220 CONTINUE
C
      DO 225 K=1,2
      DO 225 J=1,JM
      SPH(J,K) = SIN(PH(J,K))
      CPH(J,K) = COS(PH(J,K))
      DX(J,K) = AE*DLM*CPH(J,K)
  225 CONTINUE
      CPH(1,2)  = 0.0
      CPH(JM,2) = 0.0
      DX(1,2)   = 0.0
      DX(JM,2)  = 0.0
C
      DO 226 J=1,JMM1
      RH1JK(J,1) = ONE / (AE*CPH(J,1))
  226 CONTINUE
      DO 227 J=2,JMM1
      RH1JK(J,2) = ONE / (AE*CPH(J,2))
  227 CONTINUE
      RH1JK(1,2)  = 0.0
      RH1JK(JM,1) = 0.0
      RH1JK(JM,2) = 0.0
C
      DO 5010 J=1,JM
      II = (J-1)*IMP3
      DO 5009 I=1,IMP3
      PHV(II+I) =  PH(J,1)
      PHU(II+I) =  PH(J,2)
      SPHV(II+I) = SPH(J,1)
      SPHU(II+I) = SPH(J,2)
      CPHV(II+I) = CPH(J,1)
      CPHU(II+I) = CPH(J,2)
      RH1V(II+I) = RH1JK(J,1)
      RH1U(II+I) = RH1JK(J,2)
      WK1(II+I) =  DX(J,2)
 5009 CONTINUE
 5010 CONTINUE
C
      DO 215 I=1,IJM2M0
      TEM       = 1.0 / ((DY*DY)  * CPHU(I1+I))
      CD1(I1+I) = 1.0 / (WK1(I1+I)*WK1(I1+I))
      CD2(I1+I) = TEM * CPHV(I1+I)
      CD3(I1+I) = TEM * CPHV(I)
  215 CONTINUE
C
C  K=1 GIVES THE ANGLE LAMDA AT THE U-POINTS
C  K=2 GIVES THE ANGLE LAMDA AT THE H-POINTS AND THE V-POINTS
C
      DO 221 I=1,IM
      BLMIK(I,2) = (I-1)*DLM
      BLMIK(I,1) = BLMIK(I,2) +  0.5*DLM
  221 CONTINUE
      DO 222 I=1,3
      BLMIK(IM+I,1) = BLMIK(I,1)
      BLMIK(IM+I,2) = BLMIK(I,2)
  222 CONTINUE
      DO 223 K=1,2
      DO 223 I=1,IM
      CLM(I,K) = COS(BLMIK(I,K))
      SLM(I,K) = SIN(BLMIK(I,K))

      CLM(I,K+2) = COS(2.0*BLMIK(I,K))
      SLM(I,K+2) = SIN(2.0*BLMIK(I,K))

      CLM(I,K+4) = COS(3.0*BLMIK(I,K))
      SLM(I,K+4) = SIN(3.0*BLMIK(I,K))
  223 CONTINUE
C
C
      DO 230 J=2,JMM1
      CDIVU(J)  = ONE  / DX(J,2)
      CDIVV(J)  = ONE  / (DY*CPH(J,2))
  230 CONTINUE
C
C
      AREA   = 0.0
      DO 2005 J=2,JMM1
      DO 2005 I=1,IM
      AREA   = AREA + (DX(J,2)*DY)
 2005 CONTINUE
      ARE2   = AREA + IM * DY * DX(1,1) * 0.5
      AREA   = AREA + 2.0 * PI * DY*DY*0.25
C
      DO 2007 J=2,JMM1
      II = (J-1)*IMP3
      DO 2007 I=1,IMP3
      CDU(II+I) = CDIVU(J)
      CDV(II+I) = CDIVV(J)
 2007 CONTINUE
C
      DO 8888 J=1,JM
      II = (J-1)*IMP3
      DO 8888 I=1,IMP3
      xcr(II+I,1) = (I - 1.0) * dlm
      xcr(II+I,2) = (I - 0.5) * dlm
 8888 continue

      RETURN
      END

      SUBROUTINE GLMNP2(IMP3, JM, SRP, DX, DY, ARE2, DXV, GLBM)
C
      DIMENSION SRP(IMP3,JM), DX(JM)
      double precision dglbm
C
      IM   = IMP3 - 3
      JMM1 = JM - 1
      DYBA = DY / ARE2
C
      DGLBM = (SRP(1,1) + SRP(1,JM)) * (DYBA*DXV*0.25*IM)
      DO 3005 J=2,JMM1
      DO 3005 I=1,IM
      DGLBM = DGLBM + SRP(I,J) * (DX(J)*DYBA)
 3005 CONTINUE
      GLBM  = DGLBM
C
      RETURN
      END

      SUBROUTINE INTER(IEM, JEM, IMP3, JM, FEC, FSL, WRK)
C
      DIMENSION FEC(IEM,JEM), FSL(IMP3,JM)
      DIMENSION WRK(IMP3,JEM)
C
      IM = IMP3 - 3
      JMM1 = JM - 1
C
      if (iem-1 .eq. im .and. jem .eq. jmm1) then
         do 5 j=2,jmm1
         do 5 i=1,im
         fsl(i,j) = fec(i,j-1)
    5    continue
         do 6 i=1,im
         wrk(i,1)     = fec(i,1)
         wrk(i,jem-1) = fec(i,jem-1)
    6    continue
      else
C
         DLON = 360.0 / FLOAT(IM)
         DLAT = 180.0 / FLOAT(JMM1)
         DLOE = FLOAT(IEM-1) / FLOAT(IM)
         DLAE = FLOAT(JEM)   / FLOAT(JMM1)
         FEC(1,:) = FEC(IEM,:)
C
C     FEC(IEM,:) = FEC(1,:)
         DO 20 J=1,JEM
         DO 10 I=1,IM
         XLON = (I-1) * DLOE + 1
         ILON = XLON
         XLON = XLON - ILON
         WRK(I,J) = (1.0-XLON)*FEC(ILON,J) + XLON*FEC(ILON+1,J)
   10    CONTINUE
   20    CONTINUE
C
         DO 50 J=2,JMM1
         YLAT =  (J-1) * DLAE
         JLAT = YLAT
         YLAT = YLAT - JLAT
         IF (JLAT .GT. 0 .AND. JLAT .LT. JEM-1) THEN
            DO 40 I=1,IM
            FSL(I,J) = (1.0-YLAT)*WRK(I,JLAT) + YLAT*WRK(I,JLAT+1)
   40       CONTINUE
         ELSEIF (JLAT .LE. 0) THEN
            DO 42 I=1,IM
            FSL(I,J) = WRK(I,1)
   42       CONTINUE
         ELSE
            DO 43 I=1,IM
            FSL(I,J) = WRK(I,JEM-1)
   43       CONTINUE
         ENDIF
C
   50    CONTINUE
      endif
C
      TEMS = 0.0
      TEMN = 0.0
      DO 60 I=1,IM
      TEMS = TEMS + WRK(I,1)
      TEMN = TEMN + WRK(I,JEM-1)
   60 CONTINUE
      TEMS = TEMS / FLOAT(IM)
      TEMN = TEMN / FLOAT(IM)
C
      DO 65 I=1,IM
      FSL(I,1)  = TEMS
      FSL(I,JM) = TEMN
   65 CONTINUE
C
      CALL WRAP (1,IMP3*JM,FSL(1,1))
C
      RETURN
      END
      SUBROUTINE WRAP(IB,IE,XX)
      include "slgcm.slgprm"
      DIMENSION XX(IJM0M0)
C
      DO 10 I=IB,IE,IMP3
      XX(IM+I)   = XX(I)
      XX(IMP1+I) = XX(I+1)
      XX(IMP2+I) = XX(I+2)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE CONDT(DT)
C
      include "slgcm.slgprm"
      include "slgcm.slgclm"
      include "slgcm.slgwrk"
      include "slgcm.slgcon"
C
      INTEGER DT
C
C     SAVE
C
      CDA = CDF * CDAMP
      CDB = (2.0 - CDF) * CDAMP
C
      PRINT *,' CDAMP=',CDAMP, ' CDA=',CDA,' CDB=',CDB
C
      DTOA   = DT/AE
      DTHF   = DT*0.5
      DTHFSQ = DTHF*DTHF
      DL1DT  = DL1 * DT
      DL2DT  = DL2 * DT
      HFCDDT = CDA*DL1DT
C
C PRECOMPUTE ARRAYS AT V POINTS
C
        DO 1226 J=1,JM
C
        FCOR(J,1)  = TWOM * SPH(J,1)
        FDTHF(J,1) = FCOR(J,1) * DL1DT
        FVSQ(J)    = FDTHF(J,1) * FDTHF(J,1)
        ARR1(J,1)  = ONE / (ONE + FVSQ(J))
        ARR2(J,1)  = FDTHF(J,1) / (ONE + FVSQ(J))
        ARR5(J)    = DL1DT * ARR2(J,1) * RH1JK(J,1)
        ARR6(J)    = DL1DT * ARR1(J,1) * RA
        F1M(J,1)   =(ONE - FVSQ(J))   * ARR1(J,1)
C
C PRECOMPUTE ARRAYS AT U POINTS
C
        FCOR(J,2)  = TWOM*SPH(J,2)
        FDTHF(J,2) = FCOR(J,2)  * DL1DT
        FUSQ(J)    = FDTHF(J,2) * FDTHF(J,2)
        ARR1(J,2)  = ONE / (ONE + FUSQ(J))
        ARR2(J,2)  = FDTHF(J,2) / (ONE + FUSQ(J))
        ARR3(J)    = DL1DT * ARR1(J,2) * RH1JK(J,2)
        ARR4(J)    = DL1DT * ARR2(J,2) * RA
        F1M(J,2)   = (ONE - FUSQ(J))  * ARR1(J,2)
C
 1226 CONTINUE
C
C
      TEM  = DPH * DPH * DL1DT * TWOM * 0.5 / (DLM*DY*DY)
      AESQ = AE * AE
      DO 240 J=2,JMM1
      TEM1 = 1.0 / (DX(J,2) * DX(J,2))
      TEM2 = TEM * (1.0 - FUSQ(J)) * ARR1(J,2)
      TEM5 = ONE / (ARR1(J,2) * DY * DY *CPH(J,2))
      TEM3 = ARR1(J,1)   * CPH(J,1)   * TEM5
      TEM4 = ARR1(J-1,1) * CPH(J-1,1) * TEM5
      II = (J-1) * IMP3
      DO 235 I=1,IMP3
      CDW(II+I) = TEM1 + TEM2
      CDE(II+I) = TEM1 - TEM2
      CDN(II+I) = TEM3
      CDS(II+I) = TEM4
C
  235 CONTINUE
C
      CDN2(J) = ARR1(J,1) * CPH(J,1) / (CPH(J,2) *  DY*DY)
      CDS2(J) = ARR1(J-1,1) * CPH(J-1,1) / (CPH(J,2) * DY*DY)
      CDC1(J) = ARR1(J,2) / (CPH(J,2) * CPH(J,2) *AESQ)
      CDC2(J) = ARR1(J,2)*ARR1(J,2) *(1.0-FUSQ(J))*(DL1DT*TWOM) / AESQ
C
  240 CONTINUE
      CDC1(1)  = 4.0 * ARR1(1,1) / (DY*DY)
      CDC1(JM) = 4.0 * ARR1(JMM1,1) / (DY*DY)
C
c     PRINT *,' ARR1=',ARR1
C     PRINT *,' CDW=',CDW
C     PRINT *,' CDE=',CDE
C     PRINT *,' CDN=',CDN
C     PRINT *,' CDS=',CDS
c     PRINT *,' CDN2=',CDN2
c     PRINT *,' CDS2=',CDS2
c     PRINT *,' CDC1=',CDC1
c     PRINT *,' CDC2=',CDC2
C
C     
      SQMU = 1.0/(DL1DT*DL1DT*FI0+CDA*DL1DT)
C
      PRINT *,' SQMU=',SQMU
C
      RETURN
      END
      SUBROUTINE AVRX3(U,V)
      include "slgcm.slgprm"
      include "slgcm.slgwrk"
C
C*********************************************************************
C*********************** SLGCM   MODEL *******************************
C********************* SUBROUTINE AVRX *******************************
C********************** 08 OCTO    1992 ******************************
C*********************************************************************
C
C
      PARAMETER (NLATS=JM/8)
C
      INTEGER   TOTLATS, TEMPSIZE, FORWARD, BACKWARD
C
      PARAMETER (TOTLATS=4*NLATS)
      PARAMETER (TEMPSIZE=TOTLATS*IMP2, ITRG=3*IMP2+1)
      PARAMETER (FORWARD=-1,BACKWARD=1)
C
C  ARGUMENTS
C
      DIMENSION    U(IMP3,JM), V(IMP3,JM)
     *,            S(IMP2,TOTLATS), TR(ITRG), IX(IM)
C
C   LOCALS
C
      LOGICAL        FIRST
C
C   SCRATCH SPACE ALLOCATION
C
      DIMENSION      A(IMP2,TOTLATS), B(IM*2,TOTLATS)
      DIMENSION      F(IMP2,JMM1),    Z(IMP3,TOTLATS)
C
      DATA           FIRST/.TRUE./
      DATA S/TEMPSIZE*0.0/, TR/ITRG*0.0/, IX/IM*0/
      SAVE
C
C   INITIALIZATION ON FIRST CALL
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C
         DO 10 I=1,IMP2*JMM1
         F(I,1) = 1.
   10    CONTINUE
         CONS   = ONE / COS(-PI/TWO+(NLATS+1)*(PI/JMM1))
C
         DO 100 I=4,IM
         ANGI = SIN((I/2)*PI/IM)
         DO 100 J=2,JMM1
         TEM      = CONS * COS(-PI/TWO + (J-1)*(PI/JMM1))
         F(I+1,J) = MIN(TEM*TEM/ANGI,ONE)
100      CONTINUE
C
         DO 200 I=1,IMP2
         DO 200 J=1,NLATS
         S(I,J      ) = F(I,         1 +J)
         S(I,J+NLATS) = F(I,JM-NLATS-1 +J)
         S(I,J+2*NLATS) = S(I,J)
         S(I,J+3*NLATS) = S(I,J+NLATS)
200      CONTINUE
C
         CALL FFTFAX(IM, IX, TR)
C
      ENDIF
C
C       END INITIALIZATION
C**********************************************************************
C       BEGIN STANDARD CASE
C
C   COPY LATITUDES TO BE SMOOTHED INTO CONTIGUOUS BUFFER
C
      IOFF = 1
      DO 1003 I=1,IMP3*NLATS
      Z(I,IOFF)         = U(I,2)
      Z(I,NLATS+IOFF)   = U(I,JM-NLATS)
      Z(I,2*NLATS+IOFF) = V(I,2)
      Z(I,3*NLATS+IOFF) = V(I,JM-NLATS)
1003  CONTINUE
C
C   TRANSFORM AND FILTER
C
      DO 1100 J=1,TOTLATS
      DO 1100 I=1,IMP2
      A(I,J) = Z(I,J)
1100  CONTINUE
C
      CALL RFFTMLT(A,B,TR,IX,1,IMP2,IM,TOTLATS,FORWARD)
C
      DO 1110 I=1,IMP2*TOTLATS
      A(I,1) = A(I,1)*S(I,1)
 1110 CONTINUE
C
      CALL RFFTMLT(A,B,TR,IX,1,IMP2,IM,TOTLATS,BACKWARD)
C
      DO 1500 J=1,TOTLATS
      DO 1450 I=1,IM
      Z(I,J) = A(I,J)
1450  CONTINUE
      Z(IMP1,J) = Z(1,J)
      Z(IMP2,J) = Z(2,J)
      Z(IMP3,J) = Z(3,J)
1500  CONTINUE
C
C   COPY BACK FROM CONTIGUOUS BUFFER
C
      IOFF = 1
      DO 1645 I=1,IMP3*NLATS
      U(I,2)        = Z(I,IOFF)
      U(I,JM-NLATS) = Z(I,NLATS+IOFF)
      V(I,2)        = Z(I,2*NLATS+IOFF)
      V(I,JM-NLATS) = Z(I,3*NLATS+IOFF)
1645  CONTINUE
C
      RETURN
      END
      SUBROUTINE ENGCH(TKEU,TKEV,TKE,POL,EG,GMASS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     This subroutine calculates the global integral of energy   C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      include "slgcm.slgprm"
      include "slgcm.slgprg"
      include "slgcm.slgcon"

      DIMENSION AU(JM), AV(JM), AG(JM)

      DO J = 2, JMM1
         AU(J) = (AE**2)*DPH*DLM*CPH(J,2)
      ENDDO
      
      AU(1) = 0.25*(AE**2)*(DPH**2)*PI
      AU(JM) = AU(1)

      AG(:) = AU(:)

      DO J = 1, JMM1
         AV(J) = (AE**2)*DPH*DLM*CPH(J,1)
      ENDDO

      TKEU = 0.0
      TKEV = 0.0
      POL = 0.0
      EG = 0.0
      GMASS = 0.0

      AAA0 = 6.0*PI*(AE**2)

      DO JJ = 2, JMM1
         DO II = 1, IM
            I = (JJ-1)*IMP3 + II
            TKEU = TKEU + 0.5*(UN0(I)**2)*AU(JJ)*FI0
            POL = POL + 0.5*(GTP(I)**2)*AG(JJ)/9.8
            GMASS = GMASS + GTP(I)*AG(JJ)
         ENDDO
      ENDDO

      TKEU = TKEU + 0.5*(UN0(1)**2)*AU(1)*FI0
     #     + 0.5*(UN0(IJM0M0)**2)*AU(JM)*FI0
      POL = POL + 0.5*(GTP(1)**2)*AG(1)/9.8
     #          + 0.5*(GTP(IJM0M0)**2)*AG(JM)/9.8
      GMASS = GMASS + GTP(1)*AG(1) + GTP(IJM0M0)*AG(JM)

      GMASS = GMASS/(AAA0*9.81)

      DO JJ = 1, JMM1
         DO II = 1, IM
            I = (JJ-1)*IMP3 + II
            TKEV = TKEV + 0.5*(VN0(I)**2)*AV(JJ)*FI0
         ENDDO
      ENDDO

      TKE = (TKEU + TKEV)/9.8
      EG = TKE + POL

      RETURN
      END


      SUBROUTINE INIT(KRSI)

      include "slgcm.slgprm"
      include "slgcm.slgprg"
      include "slgcm.slgcon"

      CHARACTER*10 ABC
      DIMENSION AAAU(IM,JM), AAAV(IM,JM), AAAF(IM,JM)

      COMMON /MEAN/ FMEAN

      OPEN(UNIT=KRSI, FILE='INIT.DATA', STATUS='OLD'
     #     ,    FORM='FORMATTED')

      READ(KRSI,711) ABC
      READ(KRSI,911) ((AAAU(I,J),I=1,IM),J=1,JM)
      READ(KRSI,911) ((AAAV(I,J),I=1,IM),J=1,JM)
      READ(KRSI,911) ((AAAF(I,J),I=1,IM),J=1,JM)

      FMAX = AAAF(1,1)
      DO II=1, IM
         DO JJ=1, JM
            IIJJ = (JJ-1)*IMP3 + II
            UN0(IIJJ) = AAAU(II,JJ)
            VN0(IIJJ) = AAAV(II,JJ)
            GTP(IIJJ) = AAAF(II,JJ)
            IF(FMAX.LT.AAAF(II,JJ)) FMAX = AAAF(II,JJ)
         ENDDO
      ENDDO

      CALL WRAP(1, IJM0M0, GTP(1))
      CALL GLMNP2(IMP3, JM, GTP, DX, DY, ARE2, DX(1,1), FMEAN)

      GTP(:) = GTP(:) - FMEAN
      CALL WRAP(I1P1,IJM1M0, UN0(1))
      CALL WRAP(1,   IJM1M0, VN0(1))
      CALL WRAP(1,   IJM0M0, GTP(1))
      CALL FILPU(UN0(1))
      CALL FILPV(VN0(1))

      CLOSE(KRSI)

      PRINT*, ' FMEAN =',FMEAN, ' FI0=', FI0, ' FMAX=', FMAX
                                                      
 711    format(10x,A10,F6.1)
 911    FORMAT(1X,10E13.6)

        RETURN
        END
